//
// Server_Pll3
//
// ******************************************************
//
// Modifying History:
// ==================
//
//  ver0.0 : 10,Feb., 1997
//           * Check Status.txt file generated by ACL
//           *If status file exists and OK read CIT.txt, ACT.txt
//           *RPC remote applications 
//
//  ver0.1 : 22nd,Feb,1997
//           * support random task ID for ADL
//
//  ver0.2 : 23rd,Feb,1997
//           * pass Server machine name to local machines
//
//  ver1.0 : 23,March,1997
//           * remove RPC , using server daemon (JSDK1.0),supported
//             by JDK1.1 for Local_Clients(servlet mode) 
//           * test only on SOLARIS
//
//  ver1.1 : 30th,March,1997
//           * test on IBM machines 
//           * attach port number when invoke local machines
//           * test paramters passing from master servlet
// 
//  ver1.2 : 8th,April,1997
//           * upgrate on Web-Server-Beta version
//           * modified to related API
//
//  ver1.3 : 10th,May,1997
//           * support sockt connection to DVM and monitor 
//             appplications running status
//
//  ver1.4 : 11th,May,1997
//           * support database (mSQL) access for CIT & ACT
//
// ******************************************************
                         
import java.io.*;
import java.net.*;
import java.sql.*;

public class Server_Pll3 {

	ServerSocket listen_socket = null;
	
	protected cvm3 CVM;

        String server_name = null ;
	int port;
	boolean status = false;	
	protected DataInputStream in;
        public int server_status=0;
        public int DVM_cmplt = 0 ;
        public boolean finished = false;
        //protected int DVM_port = 10000 ;
        public int DVM_port ; //random number generated between 10000 and 20000 

	// ACT table 
	int task_no = 0;
        int[] task_id = null ;
        String[] task_id_ch = null ;
        String[] IP = null;
        String[] mach_arch = null ;
        String[] mach_os = null ;

        String[] DB_driver = null ;

	String Server_IP = null;
        String user_ID = null;
        String app_ID = null ;
        long time0  = 0 ; 
        String DB_IP = null;
        String DB_port = null;
	String DB_ADMIN = null;

	String ProgressMsg = null;

	// fault message is need to define  and later send the number to ars.

   // ************ constructor *************************

    public Server_Pll3(cvm3 cvmMain,String server_IP,int port,String userid,String appid,long time0_par,String  DB_IP,String DB_port,String DB_ADMIN) {

	CVM = cvmMain;
	Server_IP = server_IP;
        user_ID = userid ;
        app_ID = appid ;
        time0 = time0_par;
        this.DB_IP = DB_IP;
        this.DB_port = DB_port;
        this.DB_ADMIN = DB_ADMIN;

        System.out.println("Server_IP : " + Server_IP);
        System.out.println("userID : " + user_ID);
        System.out.println("appID : " + app_ID);
        System.out.println("DB_IP : " + DB_IP);
        System.out.println("DB_port : " + DB_port);
        System.out.println("DB_ADMIN : " + DB_ADMIN);

	InetAddress local_addr;
        String local_name = null ;

        //if (port == 0) port = DEFAULT_PORT;
        this.port = port;
        try { 
		if (listen_socket == null) 
		listen_socket = new ServerSocket(port); 
	}
        catch (IOException e) { fail(e, "Exception creating server socket"); }


        // generate server name and address and pass to local machines

	try {
	   local_addr = java.net.InetAddress.getLocalHost();
	   local_name = local_addr.toString();
           
           int len = local_name.length();
           char[] local_name_ch = local_name.toCharArray();
           int begIndx=0 , i ;

           for(i=0;i<len;i++) {
            if(java.lang.Character.isDigit(local_name_ch[i]) ) {
              begIndx=i;
              break;
            }
           }

           server_name = local_name.substring(begIndx,len);

           System.out.println("**********************************************");
           System.out.println(" Server CVM.");
           System.out.println(" Port    : " + port);
           System.out.println(" Machine : " + local_name);
           System.out.println(" IP : " + server_name);
           System.out.println("**********************************************");
	   }
	catch (UnknownHostException e) {}
     

    }

// ********************************************************
// Exit with an Error message when an exception occurs.
// ********************************************************
	public static void fail(Exception e, String msg) {
		System.err.println(msg + ": " +  e);
		System.exit(1);
	}
	    

 //*************************************************
 // read ACT and get masters apps information
 //*************************************************
 
    public void read_ACT() {
        ResultSet rs = null;

	System.out.println("Server_PII3: In read_ACT");
        DBaccess sqlq = new DBaccess("jdbc:msql://" + DB_IP + ":" + DB_port + "/VDCE");
	System.out.println("Server_PII3: In read_ACT:after DBaccess");
        rs = sqlq.query("SELECT TaskNum from ApplInfo where UserID='" + user_ID + "' and ApplID='" + app_ID + "'" );
   
	System.out.println("Server_PII3: After SELECT TaskNum");
        try{
              while(rs.next()) {
		   task_no = Integer.parseInt(rs.getString(1));
              }
        } catch(SQLException sqle) {
                sqlq.end();
                System.out.println("exception in sql query");
                sqle.printStackTrace();
        } 
                sqlq.end();

		   System.out.println("Task_No : "+ task_no);
                   task_id = new int[task_no];
                   task_id_ch = new String[task_no];
                   IP = new String[task_no];
                   mach_arch = new String[task_no];
                   mach_os = new String[task_no];

        sqlq = new DBaccess("jdbc:msql://" + DB_IP + ":" + DB_port + "/VDCE_TABLES");
         rs = sqlq.query("SELECT TaskNo,MachineIP,MachineArch,MachineOS from ACT_" + user_ID + "_" + app_ID + " WHERE Role='0'");
         try {
                 int i =0;
                  while(rs.next()) {
                      task_id_ch[i]=rs.getString(1);
                      task_id[i] = Integer.parseInt(task_id_ch[i]);
                      IP[i] = rs.getString(2); 
                      mach_arch[i] = rs.getString(3); 
                      mach_os[i] = rs.getString(4);
                      System.out.print("Task # " + task_id[i]);
                      System.out.print("\tIP : "+IP[i]);
                      System.out.print("\tmach_arch : "+mach_arch[i]);
                      System.out.print("\tmach_os : "+mach_os[i]);
                      i++;
                  } // while
          } catch(SQLException sqle) {
                sqlq.end();
                System.out.println("exception in sql query");
                sqle.printStackTrace();
                } 
 
       sqlq.end();

  }


    
  //******************************************
  // socket connection to local-CVM using socket
  //*******************************************
   public void URL_sock_conn(){
        int no = 0 ;
        DB_driver = new String[task_no];

   for(no=1; no <= task_no; no++) {

     //DVM_port++;
     double ranint = java.lang.Math.random() * 10000 + 20000;
     DVM_port = (int)ranint;
     System.out.println("****task_id = "+ task_id + "DVM_port =  "+ DVM_port);
     URL_client url_conn = new URL_client(Server_IP,DB_driver,IP[no-1],DVM_port,mach_arch[no-1],mach_os[no-1],server_name,port,user_ID,app_ID,task_id_ch[no-1],no,DB_IP,DB_port,DB_ADMIN);
     url_conn.work();

     System.out.println("DB_driver: " + DB_driver[no-1]);
//connect socket to lcvms
//if DB driver does not exist, send CIT/ACT to lcvm
     Sock_Conn_L c1 = new Sock_Conn_L (this,listen_socket,task_id[no-1],task_no,DB_driver[no-1],user_ID,app_ID);

               //System.out.println("Priority of a Connection " + c1.getPriority());

       } //--- for: connection thread ----

   }

  //*******************************************
  // wait all application finish initiation
  //*******************************************
   public int wait_finish(){

  
      while(true) { 

	  if (check_ProgressMsg() == -1) {
	 	//go to Ending procedure
	        FailureEnding();
	
		return (-1);		
	  }

//need to check indivisual local cvm's status??
         if( this.server_status==task_no) { 
            System.out.print("SC:Status from Server : " + this.server_status);
	    System.out.println("SC: Task_No: " + task_no);
	    break; 
	 }                   
	 else { 
	    Thread.yield(); 
	 }
      }
	return(1);

   }


  //*******************************************
  // wait "complete" signal from DVM
  //*******************************************
    public int wait_cmplt() {
      while(true) { 

         if (check_ProgressMsg() == -1) {
                //go to Ending procedure
                FailureEnding();       
                
                return (-1);  
          }

// need to check indivisual local cvm's status?? suchas DVM_cmplt[task_no]
         if( this.DVM_cmplt==task_no) { 
  	    finished = true;
            System.out.print("SC:DVM_complt from Server : " + DVM_cmplt); 
	    System.out.println(" Task_No: " + task_no);
            System.out.println("SC:'finished' in Server : " + this.finished);
	    break; 
	 }                   
	 else { 
	    Thread.yield(); 
	 }
      }
	NormalEnding();
	return(1);
}

//********************************************
// NormalEnding() Yoonhee Kim
//*******************************************

public void NormalEnding()
{

      System.out.println("SC:Application Done!");

      System.out.println("SC:Server socket value before closing(from SERVER_PLL) :: " + listen_socket);
      try {
          listen_socket.close();
      System.out.println("SC:Closing the server socket (from SERVER_PLL).");
      System.out.println("SC:Server socket value (from SERVER_PLL) :: " + listen_socket);
        } catch (IOException ioe) {
           ioe.printStackTrace();
           System.out.println("Error in closing server listen socket");
        }

}

//************************************************************
// Failure Ending procedure
//Yoonhee Kim
//*************************************************************
public void FailureEnding() {

      System.out.println("\nSC:Failure occured. Can't Continue the processing");

      System.out.println("SC:Server socket value before closing(from SERVER_PLL) :: " + listen_socket);
      try {
          listen_socket.close();
      System.out.println("SC:Closing the server socket (from SERVER_PLL).");
      System.out.println("SC:Server socket value (from SERVER_PLL) ::" + listen_socket);
        } catch (IOException ioe) {
           ioe.printStackTrace();
           System.out.println("Error in closing server listen socket");
        }

}




  //*******************************************
  // start processing
  //******************************************
     public void work() {

        finished = false;
        server_status = 0;
        DVM_cmplt = 0 ;
        if(DVM_port==20000) DVM_port=10000;

     }

// ********************************************
  //  CHECK PROGRESSMSG IS FILLED - YOONHEE KIM
  // ********************************************

  public int check_ProgressMsg() {
  	if (ProgressMsg != null) {
  	
	cur_t timeclass = new cur_t();
        long nowtime = timeclass.work();
        System.out.println("failure catched at ServerACS= "+ nowtime);

		System.out.println("SC: **** In check_ProgressMsg");
		if (ProgressMsg.startsWith("fault")) {
			CVM.outmessage = ProgressMsg;
//			ProgressMsg = null;
			return(-1);
		}

	}
	return(1);
}
//*******************************************************

      public void get_set_up_time() {

        //get "set_up" time 
        cur_t d1 = new cur_t();
        long setup_time = d1.work()-time0; 
        System.out.println("setup time: ");
        System.out.println(setup_time);
      // update DB
        String time_str = Integer.toString((int)setup_time);
        update_t setup_t = new update_t(DB_IP, DB_port, DB_ADMIN, "2",time_str,user_ID,app_ID,-1);
        setup_t.work(); 
      }

   // *****************************************
   // Method to destroy Socket connection.
   // *****************************************

  public void destroy() {
     try { listen_socket.close(); }
     catch (IOException ioe) {}
  }

  // ****************************************************** 
  // Start the Server listening on a specified port
  // ****************************************************** 

/*
public static void main(String[] args) {
   if (args.length == 1) {
      try { 
         port = Integer.parseInt(args[0]); 
         }
      catch (NumberFormatException e) { 
         port = 0; 
      }
   }
   Server_Pll3 p1 = new Server_Pll3(port,args[0],args[1]);
   p1.work();
   }
*/

}	// END OF CLASS


